create or replace PROCEDURE CANCELA_TRANSCONTABIL(
    P_CDEMPRESA       IN  OPERACAOBEM.CDEMPRESA%TYPE,
    P_NRSEQCAPAOPEBEM IN  CAPAOPERABEM.NRSEQCAPAOPEBEM%TYPE,
    P_IDSIMULACAO     IN  OPERACAOBEM.IDSIMULOPERACAO%TYPE,
    P_CDOPERADOR      IN  OPERADOR.CDOPERADOR%TYPE,
    P_TPOPERACAO      IN  VARCHAR2,
    P_OPERACAO        IN  VARCHAR2,
    P_IDOPERACAO      IN  VARCHAR2)
AS
V_CDBEMATIVO       BEMATIVO.CDBEMATIVO%TYPE;
V_NRSEQITCAPA      ITCAPAOPERABEM.NRSEQITCAPAOPE%TYPE;
V_QTMESDEPANTE     ITCAPAOPERABEM.QTMESDEPITCANTE%TYPE;
V_VRFALTADEPANTE   ITCAPAOPERABEM.VRFALTADEPANTE%TYPE;
V_DTOPERA          ITCAPAOPERABEM.DTINCITCAPAOPER%TYPE;
V_NRSEQFECHACO     FECHAMENTOBEM.NRSEQFECHABEM%TYPE;
V_NRSEQOPERACO     CAPAOPERABEM.NRSEQCAPAOPEBEM%TYPE;
V_NRSEQFECHACO2    FECHAMENTOBEM.NRSEQFECHABEM%TYPE;
V_NRSEQOPERACO2    CAPAOPERABEM.NRSEQCAPAOPEBEM%TYPE;
V_NRSEQOPERABEM     ITCAPAOPERABEM.NRSEQOPERABEM%TYPE;
V_NRSEQFECHAFIS    FECHAMENTOBEM.NRSEQFECHABEM%TYPE;
V_NRSEQOPERAFIS    CAPAOPERABEM.NRSEQCAPAOPEBEM%TYPE;
V_GRUPOANTE        BEMATIVO.CDGRUPOBEM%TYPE;
V_TAXAANTE         BEMATIVO.VRTAXANODEPBEM%TYPE;
V_TPDEPRECANTE     BEMATIVO.CDTIPODEPREC%TYPE;
V_QTMESJADEP       BEMATIVO.QTMESJADEPBEM%TYPE;
V_VRINIDEP         BEMATIVO.VRINIDEPBEM%TYPE;
V_EXISRATE         BOOLEAN;
V_TIPOOPERIMOB     VARCHAR2(16);
V_TIPOOPERDEPR     VARCHAR2(16);
V_CDLOTE           CAPALOTE.CDLOTE%TYPE;
IDUSADO            CHAR;
MESUSADO           FLOAT;
V_NRCOEFIS         FLOAT;
NRINCEFIS          FLOAT;
V_QTMESDEPIS       FLOAT;
V_MUDAMES          FLOAT;
V_MUDATAXA         FLOAT;
V_TAXAFINAL        FLOAT;
V_TAXABASICA       FLOAT;
V_NRSEQOPERABEM2    OPERACAOBEM.NRSEQOPERABEM%TYPE;
BEGIN
   IF P_IDOPERACAO = 'OP' THEN  /* Operacional */
      IF P_OPERACAO = 'R' THEN   /* Reavaliao*/
         IF P_TPOPERACAO = 'C'THEN   /* Contbil */
            SELECT IT.CDBEMATIVO, IT.NRSEQITCAPAOPE, IT.QTMESDEPITCANTE, IT.VRFALTADEPANTE
              INTO V_CDBEMATIVO, V_NRSEQITCAPA, V_QTMESDEPANTE, V_VRFALTADEPANTE
              FROM ITCAPAOPERABEM IT, CAPAOPERABEM CO
             WHERE IT.CDEMPRESA = P_CDEMPRESA
               AND CO.CDEMPRESA = IT.CDEMPRESA
               AND CO.NRSEQCAPAOPEBEM = P_NRSEQCAPAOPEBEM
               AND CO.IDSIMULOPERABEM = P_IDSIMULACAO
               AND IT.NRSEQCAPAOPEBEM = CO.NRSEQCAPAOPEBEM
               AND IT.IDSIMULOPERABEM = CO.IDSIMULOPERABEM;
            IF V_QTMESDEPANTE IS NULL THEN
               SELECT QTMESFALTADBEM
                 INTO V_QTMESDEPANTE
                 FROM BEMATIVO
                WHERE CDEMPRESA  = P_CDEMPRESA
                  AND CDBEMATIVO = V_CDBEMATIVO;
            END IF;
            IF V_VRFALTADEPANTE IS NULL THEN
               BEGIN
                 SELECT VRFALTADEPBEM
                   INTO V_VRFALTADEPANTE
                   FROM BEMATIVO
                  WHERE CDEMPRESA  = P_CDEMPRESA
                    AND CDBEMATIVO = V_CDBEMATIVO;
               EXCEPTION
                 WHEN NO_DATA_FOUND THEN
                  V_VRFALTADEPANTE := '0';
               END;
            END IF;

           SELECT DISTINCT(NRSEQOPERABEM) /*PEGAR A SEQUENCIAL DA OPERACAO*/
            INTO V_NRSEQOPERABEM2
              FROM ITCAPAOPERABEM
            WHERE CDEMPRESA       = P_CDEMPRESA
               AND IDSIMULOPERABEM = P_IDSIMULACAO
               AND NRSEQCAPAOPEBEM = P_NRSEQCAPAOPEBEM
               AND NRSEQITCAPAOPE  = V_NRSEQITCAPA;

            UPDATE ITCAPAOPERABEM
               SET NRSEQOPERABEM = ''
             WHERE CDEMPRESA       = P_CDEMPRESA
               AND IDSIMULOPERABEM = P_IDSIMULACAO
               AND NRSEQCAPAOPEBEM = P_NRSEQCAPAOPEBEM
               AND NRSEQITCAPAOPE  = V_NRSEQITCAPA;
            UPDATE CAPAOPERABEM
               SET IDSITCAPAOPER = '1'
             WHERE CDEMPRESA       = P_CDEMPRESA
               AND IDSIMULOPERABEM = P_IDSIMULACAO
               AND NRSEQCAPAOPEBEM = P_NRSEQCAPAOPEBEM;
            UPDATE BEMATIVO
               SET QTMESFALTADBEM = V_QTMESDEPANTE,
                   VRFALTADEPBEM  = V_VRFALTADEPANTE
             WHERE CDEMPRESA  = P_CDEMPRESA
               AND CDBEMATIVO = V_CDBEMATIVO;

            DELETE FROM OPERACAOBEM   /*DELETE AS OPERACOES*/
               WHERE CDEMPRESA = P_CDEMPRESA
                  AND NRSEQOPERABEM = V_NRSEQOPERABEM2;
            V_NRSEQOPERABEM2 := '';

         ELSE /* Fiscal */
            SELECT IT.CDBEMATIVO, IT.NRSEQITCAPAOPE, IT.QTMESDEPITCANTE, IT.VRFALTADEPANTE
              INTO V_CDBEMATIVO, V_NRSEQITCAPA, V_QTMESDEPANTE, V_VRFALTADEPANTE
              FROM ITCAPAOPERABEM IT, CAPAOPERABEM CO
             WHERE IT.CDEMPRESA = P_CDEMPRESA
               AND CO.CDEMPRESA = IT.CDEMPRESA
               AND CO.NRSEQCAPAOPEBEM = P_NRSEQCAPAOPEBEM
               AND CO.IDSIMULOPERABEM = P_IDSIMULACAO
               AND IT.NRSEQCAPAOPEBEM = CO.NRSEQCAPAOPEBEM
               AND IT.IDSIMULOPERABEM = CO.IDSIMULOPERABEM;
            IF V_QTMESDEPANTE IS NULL THEN
               SELECT QTMESFALTDBEMFIS
                 INTO V_QTMESDEPANTE
                 FROM BEMATIVO
                WHERE CDEMPRESA  = P_CDEMPRESA
                  AND CDBEMATIVO = V_CDBEMATIVO;
            END IF;
            IF V_VRFALTADEPANTE IS NULL THEN
               BEGIN
                 SELECT VRFALTADEPBEM
                   INTO V_VRFALTADEPANTE
                   FROM BEMATIVO
                  WHERE CDEMPRESA  = P_CDEMPRESA
                    AND CDBEMATIVO = V_CDBEMATIVO;
               EXCEPTION
                 WHEN NO_DATA_FOUND THEN
                  V_VRFALTADEPANTE := '0';
               END;
            END IF;

           SELECT DISTINCT(NRSEQOPERABEM) /*PEGAR A SEQUENCIAL DA OPERACAO*/
            INTO V_NRSEQOPERABEM2
              FROM ITCAPAOPERABEM
            WHERE CDEMPRESA       = P_CDEMPRESA
               AND IDSIMULOPERABEM = P_IDSIMULACAO
               AND NRSEQCAPAOPEBEM = P_NRSEQCAPAOPEBEM
               AND NRSEQITCAPAOPE  = V_NRSEQITCAPA;

            UPDATE ITCAPAOPERABEM
               SET NRSEQOPERABEM   = ''
             WHERE CDEMPRESA       = P_CDEMPRESA
               AND IDSIMULOPERABEM = P_IDSIMULACAO
               AND NRSEQCAPAOPEBEM = P_NRSEQCAPAOPEBEM
               AND NRSEQITCAPAOPE  = V_NRSEQITCAPA;
            UPDATE CAPAOPERABEM
               SET IDSITCAPAOPER = '1'
             WHERE CDEMPRESA       = P_CDEMPRESA
               AND IDSIMULOPERABEM = P_IDSIMULACAO
               AND NRSEQCAPAOPEBEM = P_NRSEQCAPAOPEBEM;
            UPDATE BEMATIVO
               SET QTMESFALTDBEMFIS = V_QTMESDEPANTE,
                   VRFALTDEPBEMFIS  = V_VRFALTADEPANTE
             WHERE CDEMPRESA  = P_CDEMPRESA
               AND CDBEMATIVO = V_CDBEMATIVO;

             DELETE FROM OPERACAOBEM  /*DELETA AS OPERACOES*/
                WHERE CDEMPRESA = P_CDEMPRESA
                   AND NRSEQOPERABEM = V_NRSEQOPERABEM2;

            V_NRSEQOPERABEM2 := '';
         END IF;
      ELSE /* Transferencia Contabil*/
        /* 1- Primeiro pega os dados */
        /*1.1 - recebe BemAtivo e Data Operao*/
         SELECT IT.CDBEMATIVO, CO.DTCAPAOPEBEM, IT.QTMESDEPITCANTE, IT.CDGRUPOITCANTE,
                IT.VRTAXDEPITCANTE, IT.CDTIPDEPITCANTE
           INTO V_CDBEMATIVO, V_DTOPERA, V_QTMESDEPANTE, V_GRUPOANTE,
                V_TAXAANTE, V_TPDEPRECANTE
           FROM ITCAPAOPERABEM IT, CAPAOPERABEM CO
          WHERE IT.CDEMPRESA = P_CDEMPRESA
            AND CO.CDEMPRESA = IT.CDEMPRESA
            AND CO.NRSEQCAPAOPEBEM = P_NRSEQCAPAOPEBEM
            AND CO.IDSIMULOPERABEM = P_IDSIMULACAO
            AND IT.NRSEQCAPAOPEBEM = CO.NRSEQCAPAOPEBEM
            AND IT.IDSIMULOPERABEM = CO.IDSIMULOPERABEM;
         IF V_QTMESDEPANTE = NULL THEN
            SELECT QTMESFALTADBEM
              INTO V_QTMESDEPANTE
              FROM BEMATIVO
             WHERE CDEMPRESA  = P_CDEMPRESA
               AND CDBEMATIVO = V_CDBEMATIVO;
         END IF;
         /*1.2 - Recebe NR.Fechamento e Nr.Capa da Operao*/
         /* PARTE CONTBIL*/
         SELECT DISTINCT  FB.NRSEQFECHABEM , CO.NRSEQCAPAOPEBEM
           INTO V_NRSEQFECHACO, V_NRSEQOPERACO
           FROM FECHAMENTOBEM FB, ITCAPAOPERABEM IT, CAPAOPERABEM CO, OPERACAOBEM OP,
                TIPOOPERBEM  TB
          WHERE FB.CDEMPRESA  = P_CDEMPRESA
            AND IT.CDEMPRESA  = FB.CDEMPRESA
            AND CO.CDEMPRESA  = FB.CDEMPRESA
            AND OP.CDEMPRESA  = FB.CDEMPRESA
            AND TRUNC(FB.DTFECHABEM) = TRUNC(V_DTOPERA)
            AND IT.CDBEMATIVO = V_CDBEMATIVO
            AND OP.CDBEMATIVO = IT.CDBEMATIVO
            AND CO.NRSEQFECHABEM = FB.NRSEQFECHABEM
            AND OP.NRSEQOPERABEM = IT.NRSEQOPERABEM
            AND CO.CDTIPOOPERBEM = TB.CDTIPOOPERBEM
            AND TB.IDTIPOOPERBEM = '09'
            AND OP.IDTIPOFECHAOPER = 'C'
            AND TRUNC(OP.DTOPERABEM) = TRUNC(FB.DTFECHABEM)
            AND IT.NRSEQCAPAOPEBEM = CO.NRSEQCAPAOPEBEM;
         /* PARTE FISCAL*/
         SELECT DISTINCT  FB.NRSEQFECHABEM , CO.NRSEQCAPAOPEBEM
           INTO V_NRSEQFECHAFIS, V_NRSEQOPERAFIS
           FROM FECHAMENTOBEM FB, ITCAPAOPERABEM IT, CAPAOPERABEM CO, OPERACAOBEM OP,
                TIPOOPERBEM  TB
          WHERE FB.CDEMPRESA  = P_CDEMPRESA
            AND IT.CDEMPRESA  = FB.CDEMPRESA
            AND CO.CDEMPRESA  = FB.CDEMPRESA
            AND OP.CDEMPRESA  = FB.CDEMPRESA
            AND TRUNC(FB.DTFECHABEM) = TRUNC(V_DTOPERA)
            AND IT.CDBEMATIVO = V_CDBEMATIVO
            AND OP.CDBEMATIVO = IT.CDBEMATIVO
            AND CO.NRSEQFECHABEM = FB.NRSEQFECHABEM
            AND OP.NRSEQOPERABEM = IT.NRSEQOPERABEM
            AND CO.CDTIPOOPERBEM = TB.CDTIPOOPERBEM
            AND TB.IDTIPOOPERBEM = '09'
            AND OP.IDTIPOFECHAOPER = 'F'
            AND TRUNC(OP.DTOPERABEM) = TRUNC(FB.DTFECHABEM)
            AND IT.NRSEQCAPAOPEBEM = CO.NRSEQCAPAOPEBEM;
         /* DELETA FECHAMENTO OPERACIONAL TIPO CONTBIL */


         SELECT DISTINCT(NRSEQOPERABEM) /*PEGAR A SEQUENCIAL DA OPERACAO CONTBIL*/
            INTO V_NRSEQOPERABEM2
            FROM ITCAPAOPERABEM
            WHERE CDEMPRESA  = P_CDEMPRESA
           AND CDBEMATIVO = V_CDBEMATIVO
           AND IDSIMULOPERABEM = P_IDSIMULACAO
           AND NRSEQCAPAOPEBEM = V_NRSEQOPERACO;

         DELETE FROM ITCAPAOPERABEM
         WHERE CDEMPRESA  = P_CDEMPRESA
           AND CDBEMATIVO = V_CDBEMATIVO
           AND IDSIMULOPERABEM = P_IDSIMULACAO
           AND NRSEQCAPAOPEBEM = V_NRSEQOPERACO;

         DELETE FROM CAPAOPERABEM
         WHERE CDEMPRESA  = P_CDEMPRESA
           AND IDSIMULOPERABEM = P_IDSIMULACAO
           AND NRSEQCAPAOPEBEM = V_NRSEQOPERACO;
         DELETE FROM FECHAMENTOBEM
         WHERE CDEMPRESA  = P_CDEMPRESA
           AND IDSIMULFECHABEM = P_IDSIMULACAO
           AND NRSEQFECHABEM = V_NRSEQFECHACO;

         DELETE FROM OPERACAOBEM /*DELETAR A OPERACAO*/
            WHERE CDEMPRESA = P_CDEMPRESA
              AND NRSEQOPERABEM = V_NRSEQOPERABEM2
              AND CDBEMATIVO = V_CDBEMATIVO;

         V_NRSEQOPERABEM2 := '';

         /* DELETA FECHAMENTO OPERACIONAL TIPO FISCAL */
        SELECT DISTINCT(NRSEQOPERABEM) /*PEGAR A SEQUENCIAL DA OPERACAO FISCAL*/
            INTO V_NRSEQOPERABEM2
            FROM ITCAPAOPERABEM
         WHERE CDEMPRESA  = P_CDEMPRESA
            AND CDBEMATIVO = V_CDBEMATIVO
            AND IDSIMULOPERABEM = P_IDSIMULACAO
            AND NRSEQCAPAOPEBEM = V_NRSEQOPERAFIS;

         DELETE FROM ITCAPAOPERABEM
         WHERE CDEMPRESA  = P_CDEMPRESA
           AND CDBEMATIVO = V_CDBEMATIVO
           AND IDSIMULOPERABEM = P_IDSIMULACAO
           AND NRSEQCAPAOPEBEM = V_NRSEQOPERAFIS;

         DELETE FROM CAPAOPERABEM
         WHERE CDEMPRESA  = P_CDEMPRESA
           AND IDSIMULOPERABEM = P_IDSIMULACAO
           AND NRSEQCAPAOPEBEM = V_NRSEQOPERAFIS;
         DELETE FROM FECHAMENTOBEM
         WHERE CDEMPRESA  = P_CDEMPRESA
           AND IDSIMULFECHABEM = P_IDSIMULACAO
           AND NRSEQFECHABEM = V_NRSEQFECHAFIS;

        DELETE FROM OPERACAOBEM /*DELETAR A OPERACAO*/
            WHERE CDEMPRESA = P_CDEMPRESA
               AND NRSEQOPERABEM = V_NRSEQOPERABEM2
               AND CDBEMATIVO = V_CDBEMATIVO;
          V_NRSEQOPERABEM2 := '';

        /* ATUALIZA BEMATIVO */
        /* Contbil */
         SELECT QTMESJADEPBEM, VRINIDEPBEM
           INTO V_QTMESJADEP, V_VRINIDEP
           FROM BEMATIVO
          WHERE CDEMPRESA  = P_CDEMPRESA
            AND CDBEMATIVO = V_CDBEMATIVO;
         UPDATE BEMATIVO
            SET CDGRUPOBEM      = V_GRUPOANTE,
                CDTIPODEPREC    = V_TPDEPRECANTE,
                VRTAXANODEPBEM  = V_TAXAANTE,
                QTMESDEPBEM     = V_QTMESDEPANTE,
                QTMESJADEPBEM   = V_QTMESJADEP,
                QTMESFALTADBEM  = V_QTMESDEPANTE - V_QTMESJADEP,
                VRJADEPBEMATIVO = V_QTMESJADEP*(V_VRINIDEP/V_QTMESDEPANTE),
                VRFALTADEPBEM   = V_VRINIDEP-(V_QTMESJADEP*(V_VRINIDEP/V_QTMESDEPANTE))
          WHERE CDEMPRESA  = P_CDEMPRESA
            AND CDBEMATIVO = V_CDBEMATIVO;
        /* Fiscal*/
          SELECT IDNOVOUSABEM, QTMESUSOBEM
            INTO IDUSADO, MESUSADO
            FROM BEMATIVO
           WHERE CDEMPRESA  = P_CDEMPRESA
             AND CDBEMATIVO = V_CDBEMATIVO;
          SELECT NVL(NRCOETIPODEPFIS,0), NVL(VRTXINCFISTPFIS,0)
            INTO V_NRCOEFIS, NRINCEFIS
            FROM TIPODEPREC
           WHERE CDEMPRESA = P_CDEMPRESA
             AND CDTIPODEPREC = V_TPDEPRECANTE;
          SELECT QTMESDEPREFISC
            INTO V_QTMESDEPIS
            FROM GRUPOBEM
           WHERE CDEMPRESA = P_CDEMPRESA
             AND CDGRUPOBEM = V_GRUPOANTE;
           IF IDUSADO = 'U' THEN
              IF  MESUSADO > V_QTMESDEPIS/2 THEN
                  V_MUDAMES := V_QTMESDEPIS/2;
              ELSE
                  V_MUDAMES := V_QTMESDEPIS - MESUSADO;
              END IF;
           ELSE
              V_MUDAMES := V_QTMESDEPIS;
           END IF;
           IF V_MUDAMES = 0 THEN
              V_MUDAMES := 1;
           END IF;
           V_TAXABASICA := (100/V_MUDAMES)*12;
           V_TAXABASICA := V_TAXABASICA + (V_TAXABASICA * (NRINCEFIS/100));
           IF V_NRCOEFIS > 0 THEN
              V_TAXAFINAL  := V_TAXABASICA * V_NRCOEFIS;
           ELSE
              V_TAXAFINAL  := V_TAXABASICA * 1;
           END IF;
           V_MUDATAXA := V_TAXAFINAL;
           V_MUDAMES := (100/V_TAXAFINAL)*12;
          UPDATE BEMATIVO
          SET CDGRUPOBEM      = V_GRUPOANTE,
              CDTIPODEPREC    = V_TPDEPRECANTE,
              VRTXANODEPBEMFI = V_MUDATAXA,
              QTMESDEPBEMFISC = V_MUDAMES,
              QTMESJADEPBEMFI = V_QTMESJADEP,
              QTMESFALTDBEMFIS = V_MUDAMES - V_QTMESJADEP,
              VRJADEPBEMFISC  = V_QTMESJADEP*(V_VRINIDEP/V_MUDAMES),
              VRFALTDEPBEMFIS = V_VRINIDEP -(V_QTMESJADEP*(V_VRINIDEP/V_MUDAMES))
          WHERE CDEMPRESA  = P_CDEMPRESA
            AND CDBEMATIVO = V_CDBEMATIVO;
         /* VOLTA CAPA */
         UPDATE CAPAOPERABEM
            SET IDSITCAPAOPER = '1'
         WHERE CDEMPRESA       = P_CDEMPRESA
           AND IDSIMULOPERABEM = P_IDSIMULACAO
           AND NRSEQCAPAOPEBEM = P_NRSEQCAPAOPEBEM;


         SELECT DISTINCT(NRSEQOPERABEM) /*PEGAR A SEQUENCIAL DA OPERACAO*/
            INTO V_NRSEQOPERABEM2
              FROM ITCAPAOPERABEM
            WHERE CDEMPRESA       = P_CDEMPRESA
               AND IDSIMULOPERABEM = P_IDSIMULACAO
               AND NRSEQCAPAOPEBEM = P_NRSEQCAPAOPEBEM;

         UPDATE ITCAPAOPERABEM
             SET NRSEQOPERABEM = ''
           WHERE CDEMPRESA = P_CDEMPRESA
               AND IDSIMULOPERABEM = P_IDSIMULACAO
               AND NRSEQCAPAOPEBEM = P_NRSEQCAPAOPEBEM;


          DELETE FROM OPERACAOBEM
             WHERE CDEMPRESA = P_CDEMPRESA
               AND NRSEQOPERABEM = V_NRSEQOPERABEM2
               AND CDBEMATIVO = V_CDBEMATIVO;
      END IF;
   ELSE /*P_IDOPERACAO = 'CO'  -  Contabilizao*/
      SELECT IT.CDBEMATIVO, CO.DTCAPAOPEBEM
        INTO V_CDBEMATIVO, V_DTOPERA
        FROM ITCAPAOPERABEM IT, CAPAOPERABEM CO
        WHERE IT.CDEMPRESA = P_CDEMPRESA
          AND CO.CDEMPRESA = IT.CDEMPRESA
          AND CO.NRSEQCAPAOPEBEM = P_NRSEQCAPAOPEBEM
          AND CO.IDSIMULOPERABEM = P_IDSIMULACAO
          AND IT.NRSEQCAPAOPEBEM = CO.NRSEQCAPAOPEBEM
          AND IT.IDSIMULOPERABEM = CO.IDSIMULOPERABEM;
      SELECT DISTINCT  FB.NRSEQFECHABEM , CO.NRSEQCAPAOPEBEM, IT.NRSEQOPERABEM
        INTO V_NRSEQFECHACO2, V_NRSEQOPERACO2, V_NRSEQOPERABEM
        FROM FECHAMENTOBEM FB, ITCAPAOPERABEM IT, CAPAOPERABEM CO, OPERACAOBEM OP,
             TIPOOPERBEM  TB
       WHERE FB.CDEMPRESA  = P_CDEMPRESA
         AND IT.CDEMPRESA  = FB.CDEMPRESA
         AND CO.CDEMPRESA  = FB.CDEMPRESA
         AND OP.CDEMPRESA  = FB.CDEMPRESA
         AND TRUNC(FB.DTFECHABEM) = TRUNC(V_DTOPERA)
         AND IT.CDBEMATIVO = V_CDBEMATIVO
         AND OP.CDBEMATIVO = IT.CDBEMATIVO
         AND CO.NRSEQFECHABEM = FB.NRSEQFECHABEM
         AND OP.NRSEQOPERABEM = IT.NRSEQOPERABEM
         AND CO.CDTIPOOPERBEM = TB.CDTIPOOPERBEM
         AND TB.IDTIPOOPERBEM = '09'
         AND OP.IDTIPOFECHAOPER = 'C'
         AND TRUNC(OP.DTOPERABEM) = TRUNC(FB.DTFECHABEM)
         AND IT.NRSEQCAPAOPEBEM = CO.NRSEQCAPAOPEBEM;
         SELECT CDLOTE
           INTO V_CDLOTE
           FROM OPERACAOBEM
          WHERE CDEMPRESA = P_CDEMPRESA
            AND NRSEQOPERABEM = V_NRSEQOPERABEM
            AND CDBEMATIVO = V_CDBEMATIVO
            AND DTOPERABEM = V_DTOPERA;
      FOR CANC_CONTAB IN (SELECT CDEMPRESA, IDSIMULOPERABEM, NRSEQCAPAOPEBEM, NRSEQITCAPAOPE, CDCONTCTBL, IDTIPOOPERCONT
                            FROM CTBLITCAPAOPER
                           WHERE CDEMPRESA = P_CDEMPRESA
                             AND IDSIMULOPERABEM = P_IDSIMULACAO
                             AND NRSEQCAPAOPEBEM = V_NRSEQOPERACO2) LOOP
          V_EXISRATE := FALSE;
          FOR C_RATEIOBEM IN (
              SELECT CDFILICCUST, CDCENTCUSBEM, VRRATEBEM
                FROM RATEIOBEM R
               WHERE R.CDEMPRESA   = P_CDEMPRESA
                 AND R.CDBEMATIVO  = V_CDBEMATIVO) LOOP
             DELETE FROM CTBLITCAPAOPER
             WHERE CDEMPRESA = CANC_CONTAB.CDEMPRESA
               AND IDSIMULOPERABEM = CANC_CONTAB.IDSIMULOPERABEM
               AND NRSEQCAPAOPEBEM = CANC_CONTAB.NRSEQCAPAOPEBEM
               AND NRSEQITCAPAOPE  = CANC_CONTAB.NRSEQITCAPAOPE
               AND CDCONTCTBL      = CANC_CONTAB.CDCONTCTBL
               AND IDTIPOOPERCONT  = CANC_CONTAB.IDTIPOOPERCONT;
          END LOOP;
          IF V_EXISRATE = FALSE THEN
             DELETE FROM CTBLITCAPAOPER
             WHERE CDEMPRESA = CANC_CONTAB.CDEMPRESA
               AND IDSIMULOPERABEM = CANC_CONTAB.IDSIMULOPERABEM
               AND NRSEQCAPAOPEBEM = CANC_CONTAB.NRSEQCAPAOPEBEM
               AND NRSEQITCAPAOPE  = CANC_CONTAB.NRSEQITCAPAOPE
               AND CDCONTCTBL      = CANC_CONTAB.CDCONTCTBL
               AND IDTIPOOPERCONT  = CANC_CONTAB.IDTIPOOPERCONT;
          END IF;
      END LOOP;
      /* ATUALIZA O FECHAMENTO CONTBIL */
     UPDATE OPERACAOBEM
        SET CDLOTE = NULL
      WHERE CDEMPRESA = P_CDEMPRESA
        AND NRSEQOPERABEM = V_NRSEQOPERABEM
        AND CDBEMATIVO = V_CDBEMATIVO
        AND DTOPERABEM = V_DTOPERA;
      DELETE FROM CAPALOTE
       WHERE CDEMPRESA = P_CDEMPRESA
         AND CDLOTE = V_CDLOTE;
      UPDATE CAPAOPERABEM
         SET NRSEQFECHABEM = V_NRSEQFECHACO2
       WHERE NRSEQCAPAOPEBEM = V_NRSEQOPERACO2
         AND P_CDEMPRESA     = CDEMPRESA
         AND P_IDSIMULACAO   = IDSIMULOPERABEM;
      UPDATE CAPAOPERABEM
         SET IDSITCAPAOPER = '2'
       WHERE V_NRSEQFECHACO2 = NRSEQFECHABEM
         AND P_CDEMPRESA     = CDEMPRESA
         AND P_IDSIMULACAO   = IDSIMULOPERABEM;
      UPDATE FECHAMENTOBEM
         SET IDSITFECHABEM = '2',
             DTCTBFECHABEM = V_DTOPERA,
             CDOPCTBFECHABEM = P_CDOPERADOR
       WHERE V_NRSEQFECHACO2 = NRSEQFECHABEM
         AND P_CDEMPRESA = CDEMPRESA
         AND P_IDSIMULACAO = IDSIMULFECHABEM;
      /*ATUALIZA A TRANSFERNCIA CONTBIL*/
      UPDATE CAPAOPERABEM
         SET IDSITCAPAOPER = '2'
       WHERE P_NRSEQCAPAOPEBEM = NRSEQCAPAOPEBEM
         AND P_CDEMPRESA     = CDEMPRESA
         AND P_IDSIMULACAO   = IDSIMULOPERABEM;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CANCELA_TRANSCONTABIL','6.05.xxx'); END;
/


